add_processor("/inv_eat.php", function ()
	local cookienumbers = {}
	local num_cookies = 0
	local add_number = function (x)
		if not cookienumbers[x] then cookienumbers[x] = 0 end
		cookienumbers[x] = cookienumbers[x] + 1
	end
	for a, b, c in string.gmatch(text, ">Lucky numbers: ([0-9]+), ([0-9]+), ([0-9]+)<") do
		num_cookies = num_cookies + 1
		add_number(tonumber(a))
		if a ~= b then
			add_number(tonumber(b))
		end
		if b ~= c and a ~= c then
			add_number(tonumber(c))
		end
	end
	if num_cookies > 0 then
		turnsplayed = tonumber(get_turns_this_run())
		newnumbers = {}
		for a, b in pairs(cookienumbers) do
--~ 			print(num_cookies, a, b)
			if b == num_cookies then
				newnumbers[turnsplayed + a] = true
			end
		end
		
		local tbl = get_ascension_state("fortune cookie numbers")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end

		local SRnumbers = {}
		for a, b in pairs(tbl) do
			if newnumbers[b] then
				SRnumbers[b] = true
			end
		end

		if table.maxn(SRnumbers) == 0 then SRnumbers = newnumbers end

		local SRnumberlist = {}
		for a, b in pairs(SRnumbers) do
			table.insert(SRnumberlist, a)
		end

		set_ascension_state("fortune cookie numbers", table_to_str(SRnumberlist))
	end
end)

add_printer("/charpane.php", function()
	local turnsthisrun = tonumber(string.match(text, "var turnsthisrun = ([0-9]+);"))
	if not turnsthisrun then return end


	local lastturn = tonumber(get_ascension_state("last semirare turn"))
	if lastturn then
		SRmin = lastturn + 158 - turnsthisrun
		SRmax = lastturn + 202 - turnsthisrun
	elseif turnsthisrun < 85 then
		SRmin = 68 - turnsthisrun
		SRmax = 82 - turnsthisrun
	end

	local tbl = get_ascension_state("fortune cookie numbers")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	all_numbers = {}
	good_numbers = {}
	for a, b in pairs(tbl) do
		turn = tonumber(b) - turnsthisrun
		table.insert(all_numbers, turn)
		if turn >= 0 then
			if SRmin and SRmax and SRmax >= 0 then
				if turn >= SRmin and turn <= SRmax then
					table.insert(good_numbers, turn)
				end
			else
				table.insert(good_numbers, turn)
			end
		end
	end
	table.sort(all_numbers)
	table.sort(good_numbers)

	color = nil
	SRnow = nil
	for _, x in pairs(good_numbers) do
		if x == 0 then
			SRnow = true
			color = "green"
		end
	end

	if table.maxn(good_numbers) > 0 then
		value = good_numbers[1]
		for x, _ in pairs(good_numbers) do
			if x > 1 then
				value = value .. "+"
			end
		end
	else
		value = "?"
	end

	tooltip = ""
	if table.maxn(all_numbers) > 0 then
		tooltip = tooltip .. "Fortune cookie numbers: " .. table.concat(all_numbers, ", ")
	else
		tooltip = tooltip .. "Fortune cookie numbers: ?"
	end
	if SRmin and SRmax and SRmax >= 0 then
		if value == "?" then
			value = SRmin .. " to " .. SRmax
		end
		tooltip = tooltip .. ", range = " .. SRmin .. " to " .. SRmax
	else
		if value ~= "?" then
			value = value .. "?"
		end
		tooltip = tooltip .. ", range = ?"
	end

	print_charpane_value({ name = "SR", value = value, tooltip = tooltip, color = color })

	if SRnow then
		text = string.gsub(text, "<body bgcolor=white", [[<body style="background-color: lightgreen"]])
		local lastsemi = get_ascension_state("last semirare encounter")
		if lastsemi then
			print_charpane_value({ name = "LastSR", value = lastsemi })
		end
	end
end)
